import  net.jscience.math.* ;


public class  CalMac {

	public char DispOp ;
	public String DispOld ;
	private String Clip ;
	public String DispProp  ;

	private boolean  fp_cal = false ;
	private boolean  nextDspClear = false ;
	public  boolean  modeRadian = false ;
	public  boolean  DispMem = false ;
	private int      operand = 0 ;
	private int      dot_right_num = 0 ;

//	private long origin = MathFP.toFP( 0) ;
//	private long memory = MathFP.toFP( 0) ;
	private myMath origin = new myMath() ;
	private myMath memory = new myMath() ;
	private myMath caltmp = new myMath() ;

	public  CalMac () {
		DispProp = "0" ;
		DispOp = ' ' ;
		DispOld = " " ;
		Clip = "0" ;
		return;
	}

	public void  SendMessage( int num){
		if( operand==CalMac.Error && num != CalMac.Fun_rst){
			return ;
		}
		switch( num){
			case  CalMac.Num_0  :
				SendNum( 0) ;
				return ;

			case  CalMac.Num_oo :
				SendNum( 0) ;
				SendNum( 0) ;
				return ;

			case  CalMac.Num_1  :
				SendNum( 1) ;
				return ;

			case  CalMac.Num_2  :
				SendNum( 2) ;
				return ;

			case  CalMac.Num_3  :
				SendNum( 3) ;
				return ;

			case  CalMac.Num_4  :
				SendNum( 4) ;
				return ;

			case  CalMac.Num_5  :
				SendNum( 5) ;
				return ;

			case  CalMac.Num_6  :
				SendNum( 6) ;
				return ;

			case  CalMac.Num_7  :
				SendNum( 7) ;
				return ;

			case  CalMac.Num_8  :
				SendNum( 8) ;
				return ;

			case  CalMac.Num_9  :
				SendNum( 9) ;
				return ;

			case  CalMac.Num_dot  :
				if( dot_right_num > 0){
					return ;
				}
				dot_right_num = 1 ;
				if( nextDspClear){
					DispProp = "0." ;
					nextDspClear = false ;
					return ;
				}
				DispProp += "." ;
				return ;

			case  CalMac.Op_minus :
				if( DispProp.equals("0")){
					DispProp = "-" ;
					nextDspClear = false ;
					return ;
				}
			case  CalMac.Op_plus  :
			case  CalMac.Op_mul :
			case  CalMac.Op_div :
			case  CalMac.Op_power :
				try {
					Calculate() ;
					operand = num ;
					setDspOp() ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_equal :
				try {
					Calculate() ;
					operand = CalMac.Op_equal ;
					DispOld = " " ;
					setDspOp() ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_sin :
				try{
					if( modeRadian){
						setDsp(  MathFP.sin( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp( MathFP.sin(
							MathFP.div(
								MathFP.mul( MathFP.toFP( DispProp), MathFP.PI),
								MathFP.toFP(180)
							)
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_cos :
				try{
					if( modeRadian){
						setDsp(  MathFP.cos( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp( MathFP.cos(
							MathFP.div(
								MathFP.mul( MathFP.toFP( DispProp), MathFP.PI),
								MathFP.toFP(180)
							)
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_tan :
				try{
					if( modeRadian){
						setDsp(  MathFP.tan( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp( MathFP.tan(
							MathFP.div(
								MathFP.mul( MathFP.toFP( DispProp), MathFP.PI),
								MathFP.toFP(180)
							)
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_asin :
				try{
					if( modeRadian){
						setDsp(  MathFP.asin( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp(  MathFP.div(
							MathFP.mul(
								MathFP.asin( MathFP.toFP(  DispProp)),
								MathFP.toFP( 180)
							),
							MathFP.PI
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_acos :
				try{
					if( modeRadian){
						setDsp(  MathFP.acos( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp(  MathFP.div(
							MathFP.mul(
								MathFP.acos( MathFP.toFP(  DispProp)),
								MathFP.toFP( 180)
							),
							MathFP.PI
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_atan :
				try{
					if( modeRadian){
						setDsp(  MathFP.atan( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp(  MathFP.div(
							MathFP.mul(
								MathFP.atan( MathFP.toFP(  DispProp)),
								MathFP.toFP( 180)
							),
							MathFP.PI
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}
			case  CalMac.Op_sinh :
				try{
					if( modeRadian){
						setDsp(  sinh( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp( sinh(
							MathFP.div(
								MathFP.mul( MathFP.toFP( DispProp), MathFP.PI),
								MathFP.toFP(180)
							)
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}
			case  CalMac.Op_cosh :
				try{
					if( modeRadian){
						setDsp(  cosh( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp( cosh(
							MathFP.div(
								MathFP.mul( MathFP.toFP( DispProp), MathFP.PI),
								MathFP.toFP(180)
							)
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}
			case  CalMac.Op_tanh :
				try{
					if( modeRadian){
						setDsp(  tanh( MathFP.toFP(  DispProp))) ;
					} else {
						setDsp( tanh(
							MathFP.div(
								MathFP.mul( MathFP.toFP( DispProp), MathFP.PI),
								MathFP.toFP(180)
							)
						)) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}
			case  CalMac.Op_exp :
				try{
					setDsp(  MathFP.exp( MathFP.toFP(  DispProp))) ;
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_ln_e :
				try{
					setDsp(  MathFP.log( MathFP.toFP(  DispProp))) ;
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}
			case  CalMac.Op_log :
				try{
					if( MathFP.toLong(MathFP.mul(MathFP.toFP(100),MathFP.toFP( DispProp))) <1){
						caltmp.set( DispProp) ;
						caltmp.mul( new myMath( 10000)) ;
						caltmp.set( MathFP.toString( log10( MathFP.toFP( caltmp.toString())))) ;
						caltmp.sub( new myMath(4)) ;
						setDsp( MathFP.toFP(caltmp.toString())) ;
					} else {
						setDsp(  log10( MathFP.toFP(  DispProp))) ;
					}
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_ln_2 :
				try{
					setDsp(  log2( MathFP.toFP(  DispProp))) ;
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Op_root  :
				try{
					setDsp(  MathFP.sqrt( MathFP.toFP(  DispProp))) ;
					nextDspClear = true ;
					return ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					setDspOp() ;
					return ;
				}

			case  CalMac.Con_pi  :
				DispProp = MathFP.toString( MathFP.PI, 5) ;
				nextDspClear = true ;
				return ;

			case  CalMac.Con_e   :
				DispProp = MathFP.toString( MathFP.E, 5) ;
				nextDspClear = true ;
				return ;

			case  CalMac.Fun_copy :
				Clip = String.valueOf( DispProp) ;
				return ;

			case  CalMac.Fun_paste :
				DispProp = String.valueOf( Clip) ;
				return ;

			case  CalMac.Fun_cls :
				DispProp = "0" ;
				dot_right_num = 0 ;
				return ;

			case  CalMac.Fun_rst :
				DispOld = " " ;
				DispProp = "0" ;
				origin.clear(); ;
				operand = CalMac.Op_space ;
				dot_right_num = 0 ;
				fp_cal = false ;
				setDspOp () ;
				return ;


			case  CalMac.Mem_plus :
				try {
//					memory = MathFP.add( memory,  MathFP.toFP(DispProp)) ;
					caltmp.set( DispProp) ;
					memory.add( caltmp) ;
					DispMem = true ;
					nextDspClear = true ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					DispMem = false ;
					setDspOp() ;
					return ;
				}
				return ;

			case  CalMac.Mem_minus :
				try {
//					memory = MathFP.sub( memory,  MathFP.toFP(DispProp)) ;
					caltmp.set( DispProp) ;
					memory.sub( caltmp) ;
					DispMem = true ;
					nextDspClear = true ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					DispMem = false ;
					setDspOp() ;
					return ;
				}
				return ;

			case  CalMac.Mem_dsp :
				try {
					setDsp( memory) ;
					nextDspClear = true ;
				} catch( ArithmeticException e){
					operand = CalMac.Error ;
					DispMem = false ;
					setDspOp() ;
					return ;
				}
				return ;

			case  CalMac.Mem_cls :
				DispMem = false ;
				origin.clear(); ;
				nextDspClear = true ;
				return ;

			case  CalMac.ModeAng :
				modeRadian ^= true ;
				if( modeRadian){

				}
				return ;

			case  CalMac.Error :
			default  :
				operand = CalMac.Error ;
				setDspOp() ;
				return  ;
		}
	}

	private void  SendNum( int num){
		if( nextDspClear || DispProp.equals("0")){
			if( nextDspClear && operand == CalMac.Op_equal){
				operand = CalMac.Op_space ;
				fp_cal = false ;
				setDspOp() ;
			}
			DispProp = String.valueOf( num) ;
			dot_right_num = 0 ;
			nextDspClear = false ;
			return ;
		}
		int length = DispProp.length() ;
		if( dot_right_num>0){
			if( dot_right_num > 5  ||  length>CalMac.KETA){
				return ;
			}
			dot_right_num++ ;
		} else {
			if( length >=CalMac.KETA){
				return ;
			}
		}
//		if( length>=11 || length-dot_right_num > CalMac.KETA){
//			return ;
//		}
		DispProp += num ;
		return ;
	}
	private void  setDsp( long fp) throws ArithmeticException {
		setmyMath( caltmp, fp) ;
		setDsp( caltmp) ;
		return ;
	}
	private void  setDsp( myMath  in) throws ArithmeticException{
		String str = in.toString () ;
		int i = str.indexOf('.') ;
		if( i>=0){
			if( str.length() > i+6){
				str = str.substring( 0, i+6) ;
			}
			int ii = str.length() -1;
			while( str.charAt(ii)=='0'){
				ii-- ;
			}
			if( i==ii){
				DispProp = str.substring( 0, i) ;
			} else {
				DispProp = str.substring( 0, ii+1) ;
			}
		} else {
			DispProp = str ;
		}
		return ;
/*		String str = MathFP.toString( fp,  4) ;
		int    tmp = str.indexOf('.') ;
		if( fp_cal || !str.substring(tmp+1).equals("0000")){
//	ȂAL7Ɋۂ߂B
			fp_cal = true ; // މZׂ͂ėLŏB̂߂̃tO
			int i = tmp ;
			tmp = str.length() ;
//	AL𒴂錅ꍇ
			if( tmp > 6){
//	Lɋyԏꍇ́Â܂܊ۂ߂
				if( i < 5){
					DispProp = MathFP.toString( fp, 5-i) ;
					return ;
//	L݂̂̏ꍇ́AŌ̌Ŋۂ߂
				} else {
					for( i-=5, tmp=1; i>0; tmp*=10, i--){
					}
//	10^nŊĊۂ߂10^n΁Aォn+1ڂŊۂ߂ƂɂȂB
					fp = MathFP.div( fp, MathFP.toFP( tmp)) ;
					fp = MathFP.round( fp, 1) ;
					fp = MathFP.toLong(fp) * tmp ;
					DispProp = String.valueOf( fp) ;
					return ;
				}
			}
// 11.11110000 Ƃ̍Ō0
			for( tmp = str.length()-1; str.charAt(tmp)=='0'; tmp--){ }
// 11.0000( -> 11.)Ȃ
			if( str.charAt(tmp)=='.'){
				DispProp = str.substring( 0, tmp) ;
				return ;
			}
			str = str.substring( 0, tmp+1) ;
//	0A\ZȂĂ܂B
			if( str.length() < CalMac.KETA){
				DispProp = str ;
				return ;
			}
			DispProp = str.substring( 0, CalMac.KETA) ;
			return ;
		} else if( tmp <= CalMac.KETA){
			DispProp = str.substring( 0, tmp) ;
			return ;
		} else {
			DispProp = str.substring( 0, CalMac.KETA) ;
			operand = CalMac.Error ;
			throw  new ArithmeticException() ;
		}
*/	}

	private void  setDspOp () {
		switch( operand){
			case  CalMac.Op_plus :
				DispOp = '+' ;
				return ;

			case  CalMac.Op_minus :
				DispOp = '-' ;
				return ;

			case  CalMac.Op_mul :
				DispOp = '*' ;
				return ;

			case  CalMac.Op_div :
				DispOp = '/' ;
				return ;

			case  CalMac.Op_power :
				DispOp = '^' ;
				return ;

			case  CalMac.Op_equal :
				DispOp = '=' ;
				return ;

			case  CalMac.Op_space :
				DispOp = ' ' ;
				return ;

			case  CalMac.Error :
				DispOp = 'E' ;
				return ;

			default :
				return ;
		}
	}

	private void  Calculate () throws ArithmeticException{
		if( DispProp.equals("-")){
			DispProp = "0" ;
		}
		switch( operand){
			case  CalMac.Op_plus :
//				origin = MathFP.add( origin, MathFP.toFP(DispProp)) ;
				caltmp.set( DispProp) ;
				origin.add( caltmp) ;
				break ;
			case  CalMac.Op_minus :
//				origin = MathFP.sub( origin, MathFP.toFP(DispProp)) ;
				caltmp.set( DispProp) ;
				origin.sub( caltmp) ;
				break ;

			case  CalMac.Op_mul :
//				if(  MathFP.toString(origin,0).length() + MathFP.toString(MathFP.toFP(DispProp),0).length()  > CalMac.KETA+4){
//					throw new ArithmeticException () ;
//				}
//				origin = MathFP.mul( origin, MathFP.toFP(DispProp)) ;
				caltmp.set( DispProp) ;
				origin.mul( caltmp) ;
				break ;

			case  CalMac.Op_div :
//				origin = MathFP.div( origin, MathFP.toFP(DispProp)) ;
				caltmp.set( DispProp) ;
				origin.div( caltmp) ;
				break ;

			case  CalMac.Op_power :
//				origin = MathFP.pow( origin, MathFP.toFP(DispProp)) ;
				setmyMath( origin, MathFP.pow( getFP( origin), MathFP.toFP(DispProp))) ;
				break ;

			default :
				origin.set( DispProp) ;
				break ;
		}
		setDsp( origin) ;
		DispOld = DispProp ;
		nextDspClear = true ;
		return ;
	}

	private static long sinh( long a) throws ArithmeticException {
		long tmp = MathFP.exp( a) ;
		return  MathFP.div(
			MathFP.sub(
				tmp,  MathFP.div(  MathFP.toFP(1), tmp)
			),
			MathFP.toFP(2)
		) ;
	}
	private static long cosh( long a) throws ArithmeticException {
		long tmp = MathFP.exp( a) ;
		return  MathFP.div(
			MathFP.add(
				tmp,  MathFP.div(  MathFP.toFP(1), tmp)
			),
			MathFP.toFP(2)
		) ;
	}
	private  static long tanh( long a) throws ArithmeticException {
		return  MathFP.div( sinh(a),  cosh(a)) ;
	}
	private  static long log10( long a) throws ArithmeticException {
		return  MathFP.div( MathFP.log(a),  MathFP.log(MathFP.toFP(10))) ;
	}
	private  static long log2( long a) throws ArithmeticException {
		return  MathFP.div( MathFP.log(a),  MathFP.log(MathFP.toFP(2))) ;
	}
	private static long getFP( myMath in) throws ArithmeticException {
		return  MathFP.toFP( in.toString()) ;
	}
	private static void setmyMath( myMath in, long fp){
		in.set( MathFP.toString( fp, 5)) ;
		return ;
	}
}


