import javax.microedition.midlet.* ;
import javax.microedition.lcdui.* ;


class CalCanvas extends Canvas implements CommandListener {
	private short[] calx = new short[17] ;
	private short[] caly = new short[17] ;
	private char[]  calc = new char[17] ;
	public  int[]   cals = new int[ 15] ;
	private int     width = getWidth () ;
	private int     height = getHeight() ;
	private int widthoffset = (width-110) / 2 + 4 ;
	private short  updatenum = -1 ;
	private short  cls_state = 0 ;
	private boolean FunDisp = false ;

	public CalMac calmac ;
	public Cal    midlet ;
	public Conf   conf ;

	public CalCanvas(Cal ml) throws Exception {
		midlet = ml ;
		int heightoffset= ((getHeight()-128) / 2) + 26 ;
		calx[ 0] = (short)(53+widthoffset) ; caly[ 0] = (short)(90+heightoffset) ;
		calx[ 1] = (short)(13+widthoffset); caly[ 1] = (short)(45+heightoffset) ;
		calx[ 2] = (short)(53+widthoffset) ; caly[ 2] = (short)(45+heightoffset) ;
		calx[ 3] = (short)(89+widthoffset) ; caly[ 3] = (short)(45+heightoffset) ;
		calx[ 4] = (short)(13+widthoffset); caly[ 4] = (short)(60+heightoffset) ;
		calx[ 5] = (short)(53+widthoffset) ; caly[ 5] = (short)(60+heightoffset) ;
		calx[ 6] = (short)(89+widthoffset) ; caly[ 6] = (short)(60+heightoffset) ;
		calx[ 7] = (short)(13+widthoffset); caly[ 7] = (short)(75+heightoffset) ;
		calx[ 8] = (short)(53+widthoffset) ; caly[ 8] = (short)(75+heightoffset) ;
		calx[ 9] = (short)(89+widthoffset) ; caly[ 9] = (short)(75+heightoffset) ;
		calx[10] = (short)(13+widthoffset); caly[10] = (short)(90+heightoffset) ;
		calx[11] = (short)(53+widthoffset) ; caly[11] = (short)   heightoffset ;
		calx[12] = (short)(53+widthoffset) ; caly[12] = (short)(30+heightoffset) ;
		calx[13] = (short)(13+widthoffset); caly[13] = (short)(15+heightoffset) ;
		calx[14] = (short)(89+widthoffset) ; caly[14] = (short)(15+heightoffset) ;
		calx[15] = (short)(53+widthoffset) ; caly[15] = (short)(15+heightoffset) ;
		calx[16] = (short)(89+widthoffset) ; caly[16] = (short)(90+heightoffset) ;
		calc[0] = '0';  calc[1] = '1';  calc[2] = '2';
		calc[3] = '3';  calc[4] = '4';  calc[5] = '5';
		calc[6] = '6';  calc[7] = '7';  calc[8] = '8';
		calc[9] = '9';  calc[10]= '.';  calc[11]= '+';
		calc[12]= '-';  calc[13]= '*';  calc[14]= '/';
		calc[15]= '=';  calc[16]= '>';
		setItems () ;
		calmac = new CalMac () ;
		conf = new Conf( this) ;
		addCommand( new Command( "clear",  Command.CANCEL,   98)) ;
		setCommandListener( this) ;
		return ;
	}

	public void  paint(Graphics g) {
try{
		g.setColor(16777215);
		g.fillRect( 0, 0, width, height) ;
		g.setColor( 130815) ;
		g.fillRect( 0, 0, width, 24) ;
		g.setColor( 0) ;
		if( calmac.DispMem){
			g.drawChar( 'M',    widthoffset, 12, g.TOP|g.LEFT) ;
		}
		if( calmac.modeRadian){
			g.drawString( "rad",    widthoffset, 0, g.TOP|g.LEFT) ;
		} else {
			g.drawString( "deg",    widthoffset, 0, g.TOP|g.LEFT) ;
		}

		g.drawString( calmac.DispOld,  width-widthoffset,   0,  g.TOP|g.RIGHT) ;
		g.drawString( calmac.DispProp,  width-widthoffset,  12,  g.TOP|g.RIGHT) ;
		g.drawChar( calmac.DispOp,    widthoffset+14, 12, g.TOP|g.LEFT) ;
		g.drawLine( 0, 24, width-1, 24) ;
		if( FunDisp){
			short i ;
			g.setColor( 12632256) ;
			for( i=16; i>=0; i--){
				g.fillRoundRect( calx[i]-15, caly[i],  28, 13,  5, 5) ;
			}
			g.setColor( 0) ;
			for( i=14; i>=0; i--){
				g.drawString( Conf.cmds[cals[i]-100], calx[i], caly[i],  g.HCENTER|g.TOP) ;
			}
			g.drawString( "conf", calx[15], caly[15],  g.HCENTER|g.TOP) ;
			g.drawChar( '<',    calx[16], caly[16],  g.HCENTER|g.TOP) ;
			return ;
		} else {
			short i ;
			g.setColor( 12632256) ;
			for( i=16; i>=0; i--){
				g.fillRoundRect( calx[i]-15, caly[i],  28, 13,  5, 5) ;
			}
			if( updatenum >= 0 && updatenum <= 16){
				g.setColor( 16743551) ;
				g.fillRoundRect( calx[updatenum]-15, caly[updatenum],  28, 13,  5, 5) ;
			}
			g.setColor( 0) ;
			for( i=16; i>=0; i--){
				g.drawChar( calc[i], calx[i], caly[i],  g.HCENTER|g.TOP) ;
			}
			updatenum = -1 ;
			return ;
		}
}catch(Exception e){
System.out.println( e) ;
e.printStackTrace();
System.out.println( e.getMessage()) ;
}
	}

	public void keyPressed( int keycode){
		keycode = getMyGameAction(keycode);
		if( FunDisp == false){
		switch( keycode){
			case  KEY_NUM0 :
				updatenum = 0 ;
				calmac.SendMessage( 0) ;
				break ;

			case  KEY_NUM1 :
				updatenum = 1 ;
				calmac.SendMessage( 1) ;
				break ;

			case  KEY_NUM2 :
				updatenum = 2 ;
				calmac.SendMessage( 2) ;
				break ;

			case  KEY_NUM3 :
				updatenum = 3 ;
				calmac.SendMessage( 3) ;
				break ;

			case  KEY_NUM4 :
				updatenum = 4 ;
				calmac.SendMessage( 4) ;
				break ;

			case  KEY_NUM5 :
				updatenum = 5 ;
				calmac.SendMessage( 5) ;
				break ;

			case  KEY_NUM6 :
				updatenum = 6 ;
				calmac.SendMessage( 6) ;
				break ;

			case  KEY_NUM7 :
				updatenum = 7 ;
				calmac.SendMessage( 7) ;
				break ;

			case  KEY_NUM8 :
				updatenum = 8 ;
				calmac.SendMessage( 8) ;
				break ;

			case  KEY_NUM9 :
				updatenum = 9 ;
				calmac.SendMessage( 9) ;
				break ;

			case  KEY_POUND :
				updatenum = -1 ;
				FunDisp = true ;
				break ;

			case  KEY_STAR :
				updatenum = 10 ;
				calmac.SendMessage( 11) ;
				break ;

			case  UP :
				updatenum = 11 ;
				calmac.SendMessage( 21) ;
				break ;

			case  DOWN :
				updatenum = 12 ;
				calmac.SendMessage( 22) ;
				break ;

			case  LEFT :
				updatenum = 13 ;
				calmac.SendMessage( 23) ;
				break ;

			case  RIGHT:
				updatenum = 14;
				calmac.SendMessage( 24) ;
				break ;

			case  FIRE :
				updatenum = 15 ;
				calmac.SendMessage( 25) ;
				break ;

			default :
				updatenum = -1 ;
				break ;
		}
		cls_state = 0 ;
		repaint () ;
		return ;
//	ȏAFunDisp == falsȅꍇ
//	ȉAFunDisp == truȅꍇ
		} else {
		FunDisp = false ;
		switch( keycode){
			case  KEY_NUM0 :
				calmac.SendMessage( cals[0]) ;
				break ;

			case  KEY_NUM1 :
				calmac.SendMessage( cals[1]) ;
				break ;

			case  KEY_NUM2 :
				calmac.SendMessage( cals[2]) ;
				break ;

			case  KEY_NUM3 :
				calmac.SendMessage( cals[3]) ;
				break ;

			case  KEY_NUM4 :
				calmac.SendMessage( cals[4]) ;
				break ;

			case  KEY_NUM5 :
				calmac.SendMessage( cals[5]) ;
				break ;

			case  KEY_NUM6 :
				calmac.SendMessage( cals[6]) ;
				break ;

			case  KEY_NUM7 :
				calmac.SendMessage( cals[7]) ;
				break ;

			case  KEY_NUM8 :
				calmac.SendMessage( cals[8]) ;
				break ;

			case  KEY_NUM9 :
				calmac.SendMessage( cals[9]) ;
				break ;

			case  KEY_POUND :
				break ;

			case  KEY_STAR :
				calmac.SendMessage( cals[10]) ;
				break ;

			case  UP :
				calmac.SendMessage( cals[11]) ;
				break ;

			case  DOWN :
				calmac.SendMessage( cals[12]) ;
				break ;

			case  LEFT :
				calmac.SendMessage( cals[13]) ;
				break ;

			case  RIGHT:
				calmac.SendMessage( cals[14]) ;
				break ;

			case  FIRE :
				conf.Config () ;
				break ;
			default :
				break ;
		}
		cls_state = 0 ;
		repaint () ;
		return ;
		}
	}

	public void commandAction( Command c, Displayable d){
		if( d != this){
			return ;
		}
		int i = c.getPriority() ;
		switch( i){
			case  9999 :
				midlet.destroyApp( true);
				return ;

			case  98 :
				if( cls_state==0 && calmac.DispOp == 'E'){
					cls_state = 1 ;
				}
				switch( cls_state){
					case  0 :
						calmac.SendMessage( 98) ;
						cls_state = 1 ;
						break ;

					default :
						calmac.SendMessage( 121) ;
					case  1 :
						calmac.SendMessage( 99) ;
						cls_state = 2 ;
						FunDisp = false ;
						break ;

				}
				repaint () ;
				return ;

			default :
				calmac.SendMessage( i) ;
				break ;
		}
		cls_state = 0 ;
		repaint () ;
		return ;
	}

	private void  setItems () {
		cals[0] = 104 ;  cals[1] = 109 ;  cals[2] = 110 ;
		cals[3] = 111 ;  cals[4] = 112 ;  cals[5] = 113 ;
		cals[6] = 114 ;  cals[7] = 106 ;  cals[8] = 107 ;
		cals[9] = 108 ;  cals[10] = 105 ;  cals[11] = 118 ;
		cals[12] = 119 ;  cals[13] = 121 ;  cals[14] = 120 ;
		return ;
	}

	public void  setDefault () throws Exception{
		setItems () ;
		calmac.modeRadian = false ;
//		calmac.****** = true ;
		Display.getDisplay(midlet).setCurrent(this);
		conf = new Conf( this) ;
		return ;
	}
	private int getMyGameAction(int keycode){
		switch( keycode){
			case  KEY_NUM0 :
			case  KEY_NUM1 :
			case  KEY_NUM2 :
			case  KEY_NUM3 :
			case  KEY_NUM4 :
			case  KEY_NUM5 :
			case  KEY_NUM6 :
			case  KEY_NUM7 :
			case  KEY_NUM8 :
			case  KEY_NUM9 :
			case  KEY_POUND :
			case  KEY_STAR :
				return  keycode ;
			default:
				return  getGameAction(keycode) ;
		}
	}
}
